// Generated by CoffeeScript 1.12.0
(function() {
  var Promise, cp, execFile, mkdir, path, readFile, rmdir, spawn0, tmpDir0, tmpFileName, writeFile, writeJson,
    slice = [].slice;

  Promise = require("bluebird");

  cp = require("child_process");

  execFile = Promise.promisify(cp.execFile);

  readFile = Promise.promisify(require("fs").readFile);

  writeFile = Promise.promisify(require("fs").writeFile);

  mkdir = Promise.promisify(require("mkdirp"));

  rmdir = Promise.promisify(require("rimraf"));

  path = require("path");

  spawn0 = function(cwd, env) {
    return function() {
      var args, executable;
      executable = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      return execFile(executable, args, {
        cwd: cwd,
        env: env
      });
    };
  };

  tmpFileName = function() {
    var buf, crypto;
    crypto = require("crypto");
    buf = crypto.randomBytes(20);
    return path.join(require("os").tmpdir(), buf.toString("hex"));
  };

  tmpDir0 = function() {
    var name;
    name = tmpFileName();
    return mkdir(name).then(function() {
      return name;
    });
  };

  writeJson = function(file, data) {
    return writeFile(file, JSON.stringify(data, null, "  "));
  };

  module.exports = function(arg) {
    var ref, ref1, ref2, spawn, tmpDir, tmpDirs;
    ref = arg != null ? arg : {}, spawn = (ref1 = ref.spawn) != null ? ref1 : spawn0, tmpDir = (ref2 = ref.tmpDir) != null ? ref2 : tmpDir0;
    tmpDirs = [];
    return {
      createBundleDescriptor: function(srcDir) {
        var spawnInSrcDir;
        spawnInSrcDir = spawn(srcDir, process.env);
        return Promise.all([
          readFile(path.join(srcDir, "package.json")).then(JSON.parse), spawnInSrcDir("npm", "install").then(function() {
            return spawnInSrcDir("npm", "ls", "--parseable", "--prod");
          }).then(function(stdout) {
            return stdout.toString().split('\n');
          }).then(function(rows) {
            return rows.map(function(row) {
              return row.replace(/^.+\/([^\/]+)$/, function(_, name) {
                return name;
              });
            });
          })
        ]).then(function(arg1) {
          var author, dependencies, license, name, ref3, version;
          (ref3 = arg1[0], name = ref3.name, version = ref3.version, author = ref3.author, license = ref3.license), dependencies = arg1[1];
          return {
            name: name + "-bigpack",
            version: version,
            description: "A bundled version of " + name + " and all its dependencies",
            author: author,
            license: license,
            dependencies: {
              foo: srcDir
            },
            bundledDependencies: dependencies
          };
        });
      },
      createBundle: function(bundleDescriptor) {
        return tmpDir().then(function(dir) {
          var spawnInBundleDir;
          tmpDirs.push(dir);
          spawnInBundleDir = spawn(dir, process.env);
          return writeJson(path.join(dir, "package.json"), bundleDescriptor).then(function() {
            return spawnInBundleDir("npm", "install");
          }).then(function() {
            return spawnInBundleDir("npm", "pack");
          }).then(function() {
            var name, version;
            name = bundleDescriptor.name, version = bundleDescriptor.version;
            return path.join(dir, name + "-" + version + ".tgz");
          });
        });
      },
      cleanup: function() {
        return Promise.all(tmpDirs.map(function(dir) {
          return rmdir(dir);
        }));
      }
    };
  };

}).call(this);
